Crashpad

Public Member Functions | List of all members
crashpad::internal::MinidumpStringListWriter< MinidumpStringWriterType > Class Template Referencefinal

The writer for a MinidumpRVAList object in a minidump file, containing a list of MinidumpStringWriterType objects. More...

`#include "minidump/minidump_string_writer.h"`

Inheritance diagram for crashpad::internal::MinidumpStringListWriter< MinidumpStringWriterType >:

## Public Member Functions
void | InitializeFromVector (const std::vector< std::string > &vector)
| Adds a new Traits::MinidumpStringWriterType for each element in vector to the MinidumpRVAList. More...
void | AddStringUTF8 (const std::string &string_utf8)
| Creates a new Traits::MinidumpStringWriterType object and adds it to the MinidumpRVAList. More...
bool | IsUseful () const
| Determines whether the object is useful. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Additional Inherited Members
Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Protected Member Functions inherited from crashpad::internal::MinidumpRVAListWriter
void | AddChild (std::unique_ptr< MinidumpWritable > child)
| Adds an RVA referencing an MinidumpWritable to the MinidumpRVAList. More...
bool | IsEmpty () const
| Returns `true` if no child objects have been added by AddChild(), and `false` if child objects are present.
const std::vector< RVA > & | child_rvas () const
| Returns an object’s RVA objects referencing its children. More...
bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static const size_t | kInvalidSize
| A size value used to signal failure by methods that return `size_t`. More...

## Detailed Description

### template<typename MinidumpStringWriterType>
class crashpad::internal::MinidumpStringListWriter< MinidumpStringWriterType >

The writer for a MinidumpRVAList object in a minidump file, containing a list of MinidumpStringWriterType objects.

## Member Function Documentation

## ◆ AddStringUTF8()

template<typename MinidumpStringWriterType >

void crashpad::internal::MinidumpStringListWriter< MinidumpStringWriterType >::AddStringUTF8 | ( | const std::string & | string_utf8 | ) |

Creates a new Traits::MinidumpStringWriterType object and adds it to the MinidumpRVAList.

This object creates a new string writer with string value string_utf8, takes ownership of it, and becomes its parent in the overall tree of MinidumpWritable objects.

Note
  Valid in kStateMutable.

## ◆ InitializeFromVector()

template<typename MinidumpStringWriterType >

void crashpad::internal::MinidumpStringListWriter< MinidumpStringWriterType >::InitializeFromVector | ( | const std::vector< std::string > & | vector | ) |

Adds a new Traits::MinidumpStringWriterType for each element in vector to the MinidumpRVAList.

Parameters

  [in] | vector | The vector to use as source data. Each string in the vector is treated as a UTF-8 string, and a new string writer will be created for each one and made a child of the MinidumpStringListWriter.

Note
  Valid in kStateMutable. No mutator methods may be called before this method, and it is not normally necessary to call any mutator methods after this method.

## ◆ IsUseful()

template<typename MinidumpStringWriterType >

bool crashpad::internal::MinidumpStringListWriter< MinidumpStringWriterType >::IsUseful | ( |  | ) | const

Determines whether the object is useful.

A useful object is one that carries data that makes a meaningful contribution to a minidump file. An object carrying entries would be considered useful.

Returns
  `true` if the object is useful, `false` otherwise.

The documentation for this class was generated from the following files:

- minidump/minidump_string_writer.h
- minidump/minidump_string_writer.cc